=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2007-02-14 05:32:53 +0000
+++ bzrlib/workingtree.py	2007-02-14 09:04:00 +0000
@@ -1838,14 +1838,18 @@
         if last_rev != self.branch.last_revision():
             # merge tree state up to new branch tip.
             basis = self.basis_tree()
-            to_tree = self.branch.basis_tree()
-            if basis.inventory.root is None:
-                self.set_root_id(to_tree.inventory.root.file_id)
-            result += merge.merge_inner(
-                                  self.branch,
-                                  to_tree,
-                                  basis,
-                                  this_tree=self)
+            basis.lock_read()
+            try:
+                to_tree = self.branch.basis_tree()
+                if basis.inventory.root is None:
+                    self.set_root_id(to_tree.inventory.root.file_id)
+                result += merge.merge_inner(
+                                      self.branch,
+                                      to_tree,
+                                      basis,
+                                      this_tree=self)
+            finally:
+                basis.unlock()
             # TODO - dedup parents list with things merged by pull ?
             # reuse the tree we've updated to to set the basis:
             parent_trees = [(self.branch.last_revision(), to_tree)]

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2007-02-14 06:48:14 +0000
+++ bzrlib/workingtree_4.py	2007-02-14 09:04:00 +0000
@@ -415,8 +415,7 @@
     def unlock(self):
         """Unlock in format 4 trees needs to write the entire dirstate."""
         if self._control_files._lock_count == 1:
-            if self._hashcache.needs_write:
-                self._hashcache.write()
+            self._write_hashcache_if_dirty()
             # eventually we should do signature checking during read locks for
             # dirstate updates.
             if self._control_files._lock_mode == 'w':

